
EclaireXL - Feature #78

Get chameleon v2 working

03/05/2019 09:56 PM - foft

Status: Closed Start date: 03/05/2019

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category:  Estimated time: 0:00 hour

Target version:    

Description

Get the chameleon v2 board up and running.

History

#1 - 04/23/2019 10:11 PM - foft

we have sync...

zpu is running, tested with a display of toggling background

sdram is failing with 180 degrees

#2 - 04/23/2019 10:12 PM - foft

sdram test passes with 270 degrees! Still no boot though, will resume testing tomorrow.

#3 - 04/23/2019 10:13 PM - foft

Fiddled with sd card... blue screen and cassette boot beep. Hmmm.

#4 - 04/23/2019 10:14 PM - foft

Seems I need to remove/re-insert the sdcard to boot. PS2 doesn't seem to work, so no menu. Perhaps that is why I get the beep (consol stuck??)

#5 - 04/24/2019 10:12 PM - foft

consol is stuck because of the c64 keys supplied by chameleon 2 io. Tracking down why that is stuck, it has 3 sources: ir, docking or c64 itself

#6 - 04/28/2019 09:12 PM - foft

Stuck keys were because the remote is not part of chameleon io, I hadn't removed the external signals and they were defaulting to the wrong state.

Removed them now and typing in basic.

#7 - 04/28/2019 09:47 PM - foft

Adding the chameleon_2 shiftreg component fixed up the ps2 keyboard sometimes not working. Also plumbed the sio tx to the red led.

#8 - 04/28/2019 10:20 PM - foft

Main things to fix:

i) Joystick resetting system!

ii) sd card fiddling needed on first boot

#9 - 05/08/2019 10:46 PM - foft

Fixed issue (i)

#10 - 05/08/2019 10:46 PM - foft

Running NUMEN as a little test ;-)

#11 - 05/11/2019 03:48 PM - foft

Different sd card worked, think its a card re-initialization issue...

#12 - 05/11/2019 04:53 PM - foft

Haha, this was a known issue on the old version of the chameleon (in many cores) and this one too...

#13 - 05/11/2019 04:54 PM - foft

05/05/2025 1/3



Trying to get the ir remote working, should 'just work' since its enabled in chameleon io2 but ... it doesn't

#14 - 05/12/2019 07:45 PM - foft

Weird thing in chameleon_cdtv_remote, the timer counts when ena_1mhz is high AND halfway between. So is running at 2x the expected rate. Its not

clear why.

#15 - 05/12/2019 08:04 PM - foft

Still don't understand what the logic analyzer tells me, I'm guessing its an optimization since the hdl is pretty high level.

In any case solved the actual issue by adding a synchronizer on ir_data. Working just fine now.

#16 - 05/12/2019 09:56 PM - foft

Added back the 'return to menu'

#17 - 05/12/2019 10:51 PM - foft

Now trying to plumb in eclaire firmware 'properly'. e.g. settings/os load/save, video settings, 800 mode etc. Got it running as far as menus/drive

emulation. Had a bit of difficulty at first because I was doing some binary editing to add version, and removing some characters from the binary by

mistake!!

#18 - 05/13/2019 10:09 PM - foft

Testing video mode setting (only basic stuff, rgb/vga, no pll reprogramming) and looking ok.

Tested 3rd/4th joysticks in atari800 mode. Got them working but had to change/fix a few small things.

Want to try out flash chip next...

#19 - 05/13/2019 10:20 PM - foft

I have a 1MB slot. The core itself takes about 350KB compressed. So lets say we have 1/2 MB conservatively to store roms etc. The standard eclaire

settings saving takes 192KB.

I guess I can also allow the rpd flashing support.

So... need to plumb in correct slot address, wire up flash pins and re-enable code in firmware (+update commands?).

#20 - 05/13/2019 10:27 PM - foft

+ 3 byte header with binary length (when flashing rpd)

#21 - 05/13/2019 10:33 PM - foft

I can't see which flash chip is used, guess I'll just wire it up and try reading the id!

#22 - 05/14/2019 09:18 PM - foft

- File EN25QH128A(2T).pdf added

1c7018, which is...

EN25QH128A

datasheet attached

So, 64k blocks (erase by d8 as currently used, sector also possible)

Should just work, once I change the addresses.

#23 - 05/14/2019 09:21 PM - foft

I should be passed the slot by the microcontroller, but since I'm using sof at the moment that clearly isn't working. The firmware is currently hardcoded

to 0x200000. Which is slot 2 (but wrong half of it!). Will just give that a spin to test.

#24 - 05/14/2019 09:26 PM - foft

OK, that works

#25 - 05/18/2019 09:54 PM - foft

Picked up the slot from the micro. Computed the location of the rom. I added 256kb of blank space first to aligned to a block (this board has 64kb but

some might be 256kb...). Now loading and saving is working well.

Docs on the chameleon structure of the rom are here:

https://svn.icomp.de/svn/chaco/doc/Chameleon_USB.pdf

Its a bit misleading on the core info location, since it says it starts at 3+N, while really 3+N is the end+1 of coreinfo. It describes it right after though but

I didn't read that well!

So now its running pretty well. I'd like to get hotkeys working and I took a shortcut on eclaire and used the usb ones directly. So I need to plumb the
ps2 keys into that logic. After which I think its 'ready'.

#26 - 05/18/2019 10:09 PM - foft

Of course one more important step: try it in a C64!

#27 - 05/18/2019 10:29 PM - foft

Did the keyboard plumbing. Seems to work - okish. Though can save some bytes by doing this part in vhdl I think, so might do that.

#28 - 05/19/2019 10:25 PM - foft

Tried it in the c64. Keyboard works, but only sometimes! Need to work out why.

#29 - 05/19/2019 10:41 PM - foft

Getting some weird behaviour tonight - cores not starting etc. Unclear what the issue is...

#30 - 05/19/2019 10:52 PM - foft

Now behaving again, think Chaco had got confused and was doing weird stuff.

#31 - 05/19/2019 11:13 PM - foft

Re c64 keyboard, the state machine reading it appears to get stuck and just reads DC01 repeatedly??

#32 - 05/19/2019 11:16 PM - foft

Got a state capture when its working, goes through states as normal.

When it stops, no states are active!

#33 - 05/19/2019 11:19 PM - foft

I wonder if ba needs a synchronizer or something like that?

#34 - 05/19/2019 11:31 PM - foft

Well added a synchronizer on ba and also added a when others clause to put it back into a proper state.

Should probably discuss with Peter to see if there is a better fix.

#35 - 05/20/2019 10:34 PM - foft

- Status changed from New to Closed

Chameleon 2 is working pretty well.

Moving onto Chameleon 1 backport then will check all other cores work...
